#ifndef FUNCTIONS_H
#define FUNCTIONS_H

#include <QMainWindow>
#include <QObject>
#include <QWidget>
#include <QImage>
#include <QDebug>

#include <iostream>


#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/objdetect/objdetect.hpp>
#include <opencv2/videoio/videoio.hpp>
#include <opencv2/dnn/dnn.hpp>

typedef enum
{
    GREY8,
    RGB8,
    BRG8,
    BGR8,
}Color_type;


class functions : public QMainWindow
{
    Q_OBJECT
public:
    explicit functions(QWidget *parent = nullptr);

    int init_detect_visages(void);
    cv::Mat detect_visages(cv::Mat frame, Color_type type);

    int init_dnn(void);
    cv::Mat dnn_test(cv::Mat frame);


    cv::Mat frame_fake_gray;
    cv::Mat frame_gray;
    cv::Mat frame;
    std::vector<cv::Rect> faces;
    std::vector<cv::Rect> eyes;


    /** Global variables */
    cv::String face_cascade_name = "haarcascade_frontalface_alt.xml";
    cv::String eyes_cascade_name = "haarcascade_eye_tree_eyeglasses.xml";

    cv::CascadeClassifier face_cascade;
    cv::CascadeClassifier eyes_cascade;

private:
};

#endif // FUNCTIONS_H
