#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTimer>
#include <QString>
#include <QDebug>

#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/objdetect/objdetect.hpp>
#include <opencv2/videoio/videoio.hpp>

#include <functions.h>

#include <iostream>
using namespace std;


namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    int refreshRate;
    functions myFunctions;

    cv::Mat frame;
    cv::Mat framebw;
    QImage qt_image;


private slots:
    void on_pushButton_open_webcam_clicked();
    void on_pushButton_close_webcam_clicked();
    void update_window();

    void on_refreshRateSlider_valueChanged(int value);

private:
    Ui::MainWindow *ui;

    QTimer *timer;
    cv::VideoCapture cap;

};

#endif // MAINWINDOW_H
